Imports Microsoft.AnalysisServices.AdomdClient

Public Class ProspectAnalyzer

    Private Sub cmdAnalyze_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdAnalyze.Click
        Dim ADOMDBWpr As New ADOMDWrapper
        Dim CSet As CellSet
        Dim i, j, k As Integer
        Dim DataGridView As System.Windows.Forms.DataGridView
        Dim DataGridViewColumn As System.Windows.Forms.DataGridViewTextBoxColumn

        ' Don't do any analysis if there is no city selected
        If String.IsNullOrEmpty(cboCity.Text) Then
            Return
        End If

        ' Set the label on the buying analysis group box
        gbxBuyingAnalysis.Text = "Buying Analysis for " & cboCity.Text

        ' Call the function to get a CellSet with the results for the specified city
        CSet = ADOMDBWpr.BuyingByProductByStoreByYearMDX(cboCity.Text)

        ' Create a tab for each Page in the resulting CellSet
        TabForPages.TabPages.Clear()

        For i = 0 To CSet.Axes(2).Set.Tuples.Count - 1
            ' Label the tab using the caption for each Page in the CellSet
            TabForPages.TabPages.Add(CSet.Axes(2).Set.Tuples(i).Members(0).Caption)

            ' Place a DataGridView on the new tab
            DataGridView = New System.Windows.Forms.DataGridView
            DataGridView.ReadOnly = True
            DataGridView.Width = TabForPages.TabPages(i).Width
            DataGridView.Height = TabForPages.TabPages(i).Height
            DataGridView.RowHeadersVisible = True
            DataGridView.RowHeadersWidth = 123

            ' Create a column in the DataGridView for each Column in the CellSet
            For j = 0 To CSet.Axes(0).Set.Tuples.Count - 1
                DataGridViewColumn = New System.Windows.Forms.DataGridViewTextBoxColumn

                'The headers for the column is the caption for each Column in the CellSet
                DataGridViewColumn.HeaderText = CSet.Axes(0).Set.Tuples(j).Members(0).Caption

                DataGridViewColumn.Width = 150

                DataGridView.Columns.Add(DataGridViewColumn)
            Next

            ' Create an empty row in the DataGridView for each Row in the CellSet
            DataGridView.RowCount = CSet.Axes(1).Set.Tuples.Count

            ' The headers for each row is the caption for each Row in the CellSet
            For k = 0 To CSet.Axes(1).Set.Tuples.Count - 1
                DataGridView.Rows(k).HeaderCell.Value = CSet.Axes(1).Set.Tuples(k).Members(0).Caption
            Next

            ' Place the values from the CellSet in the DataGridView cells
            For j = 0 To CSet.Axes(0).Set.Tuples.Count - 1
                For k = 0 To CSet.Axes(1).Set.Tuples.Count - 1
                    DataGridView(j, k).Value = CSet.Cells(j, k, i).Value
                Next
            Next

            'Place the DataGridView on the tab page
            TabForPages.TabPages(i).Controls.Add(DataGridView)
        Next

        ' SEt the Buying Analysis group box visible
        gbxBuyingAnalysis.Visible = True

    End Sub
End Class
